=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2006-09-13 12:32:47 +0000
+++ bzrlib/transport/http/__init__.py	2006-09-15 09:02:21 +0000
@@ -369,13 +369,14 @@
 
     def clone(self, offset=None):
         """Return a new HttpTransportBase with root at self.base + offset
-        For now HttpTransportBase does not actually connect, so just return
-        a new HttpTransportBase object.
+        
+        We leave the daughter classes take advantage of the hint
+        that it's a cloning not a raw creation.
         """
         if offset is None:
-            return self.__class__(self.base)
+            return self.__class__(self.base, self)
         else:
-            return self.__class__(self.abspath(offset))
+            return self.__class__(self.abspath(offset), self)
 
     @staticmethod
     def range_header(ranges, tail_amount):

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2006-09-15 06:57:08 +0000
+++ bzrlib/transport/http/_urllib.py	2006-09-15 09:02:21 +0000
@@ -58,13 +58,19 @@
         """Set the base path where files will be stored."""
         super(HttpTransport_urllib, self).__init__(base)
         if from_transport is not None:
+            # Tracing transport creations that use cloning process
+            # mutter('Cloning HttpTransport_urllib '
+            #       + 'for base : [%s], from base [%s]' % (base,
+            #                                              from_transport.base))
+            # import traceback
+            # mutter(''.join(traceback.format_stack()))
             self._accept_ranges = from_transport._accept_ranges
             self._connection = from_transport._connection
             self._user = from_transport._user
             self._password = from_transport._password
         else:
             # Tracing transport creations that avoid cloning process
-            # mutter('Creating new HttpTransport_urllib')
+            # mutter('Creating new HttpTransport_urllib for base : [%s]' % base)
             # import traceback
             # mutter(''.join(traceback.format_stack()))
             self._accept_ranges = True

